#include <stdio.h>
#include <ctype.h>

#define TOTAL_COLUMN    17

/*
	This program will allow a user to dump the hex and ascii
	representation of a any file specified.  If the byte that is
	read is not a printable character, it will print a period ('.').

	This program is placed in the public domain by the author,
	David Gibbs.

*/

main(int argc,char *argv[])
{
	int column=0,character;

	char ascii[TOTAL_COLUMN+1];

	FILE *input;    /* define input file */

	/* print copyright notice */
	fprintf(stderr,"\nDUMP by David Gibbs\n\n");

	/* file name not specified, tell user syntax */
	if(argc==1) {
		fprintf(stderr,"usage: dump <filename>\n");
		exit(0);
	}

	/* try to open the file */
	if((input=fopen(argv[1],"rb"))==NULL) {
		/* we couldn't open the file */
		fprintf(stderr,"dump: error opening %s\a\n",argv[1]);
		exit(0);
	}

	/* process until end of file */
	while((character=getc(input))!=EOF) {
		/* print the byte in hex */
		printf("%2X ",character);
		/* if the byte is not a ctrl char save the byte */
		if(!iscntrl(character))
			ascii[column]=character;
		else    /* indicate that the byte is non printiable */
			ascii[column]='.';

		/* have we printed the maximum columns? */
		if(column++>TOTAL_COLUMN) {
			/* yes, print the ascii representation */
			printf("  %s\n",ascii);
			column=0;       /* reset the column counter */
		}
	}

	/* for the last line we have to pad the output */
	for(;column<=TOTAL_COLUMN+1;column++) {
		printf("   ");
		ascii[column]='\0';
	}

	/* print the ascii representation of the last line */
	printf("  %s\n",ascii);

}
